;
;_mblt.asm
;
; These routines use stos and expect direction flag to be forward.
;
; You can redistribute this file and/or modify it under the
; terms of version 2 of the GNU General Public License as
; published by the Free Software Foundation.  You should have
; received a copy of the license along with this file.
;
; This file is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty
; of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
; See LICENSE.txt more details.
;
;2014.03.11
; Moved assembly routines here.
; POASM won't let me have a 'naked' proc frame!
; The profiler does not work with __fastcall (eax/edx/ecx not saved).
;2014.04.09
; Official solid color: f->sc.

	.486
	.code
	.model flat,fastcall

bltParam	struct

rect32		struct
top		sdword ?
left		sdword ?
bottom		sdword ?
right		sdword ?
	ends

ox		sdword ?
oy		sdword ?
oz		sdword ?
vx		sdword ?
vy		sdword ?
vz		sdword ?
sc		sdword ?
opr		dd ?
opg		dd ?
opb		dd ?

cnvParam	struct
cache		sdword 8 dup (?)
hx		sword ?
hy		sword ?
rx		sdword ?
cm		sdword ?
mp		sdword ?
rtn		ptr ? ;TYP_CNV_RTN
t		ptr ?
s		ptr ?
e		ptr ?
itb		byte ptr ?
scv		ptr ? ;TYP_CNV_RTN
ssv		ptr ? ;TYP_FLS_RTN
fb		sdword ptr ?
fx		byte ptr ?
fa		byte ptr ?
fe		byte ptr ?
m		dword 5 dup (?)
ry		sdword ?
sx		dd ?
sw		dw ?
cc		db ?
ac		db ?
	ends

bmr		dw ?
bmg		dw ?
bmb		dw ?
mx		dword ?
mh		dword ?
sb		ptr ?
p		ptr byte ?
a		ptr byte ?
e		ptr byte ?
rtn		ptr ?
mlc		ptr ?
dtb		ptr byte ?
bltParam	ends
 ;typedef proto fails to take more than one param
bltRoutine	equ	fastcall uses edi,o:dword, c:dword, f:ptr

sldx		macro h
	push	ebx
 if h gt 1
	mov	edi,o
	shl	edi,h
	shl	c,h
 elseif h eq 1
	lea	edi,[o+o]
	add	c,c
 else
	mov	edi,o
 endif
	mov	ecx,c
	add	ecx,-33
	sbb	ebx,ebx
	and	cl,31
	or	ebx,80000000h
	sar	ebx,cl
	mov	cx,di
	and	ecx,31
	add	c,ecx
	shr	ebx,cl
	not	ebx
	bswap	ebx
	shr	edi,3
	and	edi,not 3
	mov	eax,f
	add	edi,[eax+bltParam.a]
	mov	eax,[eax+bltParam.sc]
	mov	ecx,[edi]
	xor	ecx,eax
	and	ecx,ebx
	xor	ecx,eax
	mov	[edi],ecx
	sub	c,32
	jle	eo

	add	edi,4
	mov	ecx,c
	shr	ecx,5
	rep stosd
	and	c,31
	jz	eo

	mov	ecx,c
	or	ebx,-1
	shr	ebx,cl
	bswap	ebx
	mov	ecx,[edi]
	xor	ecx,eax
	and	ecx,ebx
	xor	ecx,eax
	mov	[edi],ecx
eo:	pop	ebx
	endm

sldx1	proc	bltRoutine
	sldx	0
sldx1	endp

sldx2	proc	bltRoutine
	sldx	1
sldx2	endp

sldx4	proc	bltRoutine
	mov	eax,f
	mov	edi,[eax+bltParam.a]
	mov	eax,[eax+bltParam.sc]
	shr	o,1
	lea	edi,[edi+o]
	jnc	ao

	mov	cl,[edi]
	xor	cl,al
	and	cl,0F0h
	xor	cl,al
	mov	[edi],cl
	inc	edi
	dec	c
ao:	cmp	c,19
	jbe	sm

	mov	cx,di
	neg	cx
	and	ecx,3
	sub	c,ecx
	sub	c,ecx
	rep stosb
	mov	ecx,c
	shr	ecx,3
	rep stosd
	and	c,7
sm:	shr	c,1
	mov	ecx,c
	rep stosb
	jnc	eo

	mov	cl,[edi]
	xor	cl,al
	and	cl,15
	xor	cl,al
	mov	[edi],cl
eo:
sldx4	endp

sldx8	proc	bltRoutine
	mov	eax,f
	mov	edi,[eax+bltParam.a]
	add	edi,o
	mov	eax,[eax+bltParam.sc]
	cmp	c,9
	jbe	sm

	neg	o
	and	o,3
	neg	o
	add	c,o
	add	o,ao
	jmp	o

	stosb
	stosb
	stosb
ao:	mov	ecx,c
	shr	ecx,2
	rep stosd
	and	c,3
sm:	neg	c
	add	c,eo
	jmp	c

	stosb
	stosb
	stosb
	stosb
	stosb
	stosb
	stosb
	stosb
	stosb
eo:
sldx8	endp

sldx16	proc	bltRoutine
	mov	eax,f
	mov	edi,[eax+bltParam.a]
	lea	edi,[edi+o*2]
	mov	eax,[eax+bltParam.sc]
	test	di,2
	je	ao

	dec	c
	stosw
ao:	mov	ecx,c
	shr	ecx,1
	rep stosd
	jnc	eo

	mov	[edi],ax
eo:
sldx16	endp

sldx32	proc	bltRoutine
	mov	eax,f
	mov	edi,[eax+bltParam.a]
	lea	edi,[edi+o*4]
	mov	eax,[eax+bltParam.sc]
	mov	ecx,edx
	and	edx,15
	neg	edx
	add	edx,co
	jmp	edx

ao:	stosd
	stosd
	stosd
	stosd
	stosd
	stosd
	stosd
	stosd
	stosd
	stosd
	stosd
	stosd
	stosd
	stosd
	stosd
	stosd
co:	sub	ecx,16
	jns	ao
sldx32	endp

 extern _b1to8t:DWORD

b1to8	proc	fastcall uses edi,ebx d:ptr, s:ptr, c:sdword
	mov	edi,d
	mov	ecx,c
	test	ecx,ecx
	jle	eo

	xor	ebx,ebx
co:	mov	bl,byte ptr [s]
	inc	s
	mov	eax,ebx
	shr	eax,4
	mov	eax,[_b1to8t+eax*4]
	stosd
	and	ebx,15
	mov	eax,[_b1to8t+ebx*4]
	stosd
	dec	ecx	; loop instruction is slow!
	jnz	co
eo:
b1to8		endp
 end
