;
;_mblt64.asm
;
; These routines use stos and expect direction flag to be forward.
;
; You can redistribute this file and/or modify it under the
; terms of version 2 of the GNU General Public License as
; published by the Free Software Foundation.  You should have
; received a copy of the license along with this file.
;
; This file is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty
; of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
; See LICENSE.txt more details.

.code

bltParam	struct

rect32		struct
top		sdword ?
left		sdword ?
bottom		sdword ?
right		sdword ?
	ends

ox		sdword ?
oy		sdword ?
oz		sdword ?
vx		sdword ?
vy		sdword ?
vz		sdword ?
sc		sdword ?
opr		dd ?
opg		dd ?
opb		dd ?

cnvParam	struct
cache0		sdword ?
cache1		sdword ?
cache2		sdword ?
cache3		sdword ?
cache4		sdword ?
cache5		sdword ?
cache6		sdword ?
cache7		sdword ?
hx		sdword ?
rx		sdword ?
cm		sdword ?
mp		sdword ?
rtn		ptr ?
s		ptr ?
e		ptr ?
t		ptr ?
fx		ptr ?
itb		byte ptr ?
sx		dd ?
sw		dw ?
cc		db ?
ac		db ?
	ends

bmr		dw ?
bmg		dw ?
bmb		dw ?
mx		dword ?
mh		dword ?
sb		ptr ?
p		ptr byte ?
a		ptr byte ?
e		ptr byte ?
rtn		ptr ?
mlc		ptr ?
dtb		ptr byte ?
bltParam	ends
 ;typedef proto fails to take more than one param
bltRoutine	equ	public uses rdi o:dword, c:dword, f:ptr

sldx		macro h
	push	rbx
 if h gt 1
	mov	edi,o
	shl	edi,h
	shl	c,h
 elseif h eq 1
	lea	edi,[o+o]
	add	c,c
 else
	mov	edi,o
 endif
	mov	ecx,c
	add	ecx,-33
	sbb	ebx,ebx
	and	cl,31
	or	ebx,80000000h
	sar	ebx,cl		;NOTE: shift/cl on modern CPU may be slower than LUT
	mov	cx,di
	and	ecx,31
	add	c,ecx
	shr	ebx,cl
	not	ebx
	bswap	ebx
	shr	edi,3
	and	rdi,not 3
	mov	rax,f
	add	rdi,[rax].bltParam.a
	mov	eax,[rax].bltParam.sc
	mov	ecx,[rdi]
	xor	ecx,eax
	and	ecx,ebx
	xor	ecx,eax
	mov	[rdi],ecx
	sub	c,32
	jle	eo

	add	rdi,4
	mov	ecx,c
	shr	ecx,5
	rep stosd
	and	c,31
	jz	eo

	mov	ecx,c
	or	ebx,-1
	shr	ebx,cl
	bswap	ebx
	mov	ecx,[rdi]
	xor	ecx,eax
	and	ecx,ebx
	xor	ecx,eax
	mov	[rdi],ecx
eo:	pop	rbx
	endm

sldx1	proc	bltRoutine
	sldx	0
sldx1	endp

sldx2	proc	bltRoutine
	sldx	1
sldx2	endp

sldx4	proc	bltRoutine
	mov	rax,f
	mov	rdi,[rax].bltParam.a
	mov	eax,[rax].bltParam.sc
	shr	o,1
;	movsxd	rcx,o
	lea	rdi,[rdi+rcx]
	jnc	ao

	mov	ch,al
	and	ch,15
	mov	cl,[rdi]
	and	cl,0F0h
	or	cl,ch
	mov	[rdi],cl
	inc	rdi
	dec	c
ao:	cmp	c,19
	jbe	sm

	mov	cx,di
	neg	cx
	and	ecx,3
	sub	c,ecx
	sub	c,ecx
	rep stosb
	mov	ecx,c
	shr	ecx,3
	rep stosd
	and	c,7
sm:	shr	c,1
	mov	ecx,c
	rep stosb
	jnc	eo

	mov	cl,[rdi]
	xor	cl,al
	and	cl,15
	xor	cl,al
	mov	[rdi],cl
eo:
sldx4	endp

sldx8	proc	bltRoutine
	mov	rax,f
;	movsxd	rcx,o
	mov	rdi,rcx
	add	rdi,[rax].bltParam.a
	mov	eax,[rax].bltParam.sc
	cmp	c,9
	jbe	sm

	neg	rcx
	and	rcx,3
	neg	rcx
	add	c,ecx
	lea	r8,[rip+ao]
	add	r8,rcx
	jmp	r8

	stosb
	stosb
	stosb
ao:	mov	ecx,c
	shr	ecx,2
	rep stosd
	and	c,3
sm:	mov	ecx,c
	lea	r8,[rip+eo]
	sub	r8,rcx
	jmp	r8

	stosb
	stosb
	stosb
	stosb
	stosb
	stosb
	stosb
	stosb
	stosb
eo:
sldx8	endp

sldx16	proc	bltRoutine
	mov	rax,f
	mov	rdi,[rax].bltParam.a
;	movsxd	rcx,o
	lea	rdi,[rdi+rcx*2]
	mov	eax,[rax].bltParam.sc
	test	di,2
	je	ao

	dec	c
	stosw
ao:	mov	ecx,c
	shr	ecx,1
	rep stosd
	jnc	eo

	mov	[rdi],ax
eo:
sldx16	endp

sldx32	proc	bltRoutine
	mov	rax,f
	mov	rdi,[rax].bltParam.a
;	movsxd	rcx,o ; fastcall register is equal, zero extended
	lea	rdi,[rdi+rcx*4]
	mov	eax,[rax].bltParam.sc ;will zero extend rax
	test	edi,4
	jz	no

	stosd
	dec	edx
	je	eo

no:	mov	ecx,edx ;c
	mov	r8,rax
	shl	rax,32
	or	rax,r8
	and	rdx,30
	lea	r8,[rip+co]
	sub	r8,rdx
	jmp	r8

ao:	stosq
	stosq
	stosq
	stosq
	stosq
	stosq
	stosq
	stosq
	stosq
	stosq
	stosq
	stosq
	stosq
	stosq
	stosq
	stosq
co:	sub	ecx,32
	jns	ao

	test	ecx,1
	jz	eo

	mov	[rdi],eax
eo:
sldx32	endp

 extern _b1to8t:DWORD

b1to8	proc	public uses rdi	d:ptr, s:ptr, c:sdword
	mov	rdi,d
	mov	ecx,c
	test	ecx,ecx
	jle	eo

	xor	r9,r9
	lea	r8,[rip+_b1to8t]
co:	mov	r9b,byte ptr [s]
	inc	s
	mov	rax,r9
	shr	eax,4
	mov	eax,[r8+rax*4]
	stosd
	and	r9,15
	mov	eax,[r8+r9*4]
	stosd
	dec	ecx	; loop instruction is slow!
	jnz	co
eo:
b1to8		endp
 end
