/*
 lzw.h

 * You can redistribute this file and/or modify it under the
 * terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.  You should have
 * received a copy of the license along with this file.

 * This file is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See LICENSE.txt more details.
 */

#ifndef __LZW_H
 #define __LZW_H

 #ifndef __MY_CSERIES_H
  #include "my_cseries.h"
 #endif

/* ---- constants */

#define	MAX_LZW_BITS		12

/* ---- typedef */

typedef struct LZWstate
{
	int		curbit, lastbit, last_byte;
	uint8		buf[280], flag, fresh;
	int		code_size, set_code_size;
	int		max_code, max_code_size;
	int		firstcode, oldcode;
	int		clear_code, end_code;
	int16		table[2][1<<MAX_LZW_BITS];
	int16		stack[2<<MAX_LZW_BITS], *sp;
} LZWstate;

/* ---- prototypes */

int LZWReadByte(sio_func_t rf,
	const void *s,
	int flag,
	int input_code_size,
	LZWstate *lzw);
#endif
