/*
 rType.c
  global resource type database
*/

#include <enviro64.h>
#include "rType.h"

/* ---- typedefs */

typedef char	typeDesc[32];

/* ---- globals */

static const typeDesc	rsrcTypes[] =
{
	".256Shapes Collection", /* 256 */
	"8001rIcon",
	"8002rPicture",
	"8003rControlList",
	"8004rControlTemplate",
	"8005rC1InputString",
	"8006rPString",
	"8007rStringList",
	"8008rMenuBar",
	"8009rMenu",
	"800ArMenuItem",
	"800BrTextForLETextBox2",
	"800CrCtlDefproc OMF",
	"800DrCtlColorTable",
	"800ErWindParam1",
	"800FrWindParam2",
	"8010rWindColor",
	"8011rTextBlock",
	"8012rStyleBlock",
	"8013rToolStartup",
	"8014rResNames",
	"8015rAlertString",
	"8016rText",
	"8017rMenuStrg", /* may also be rCodeResource */
	"8018rCDEVCode OMF",
	"8019rCDEVFlags",
	"801ArTwoRects",
	"801BrFileTypes",
	"801CrListRef",
	"801DrCString",
	"801ErXCMD OMF",
	"801FrXFCN OMF",
	"8020rErrorString",
	"8021rKTransTable",
	"8022rWString",
	"8023rC1OutputString",
	"8024rSoundSample",
	"8025rTERuler",
	"8026rFSequence",
	"8027rCursor",
	"8028rItemStruct",
	"8029rVersion", /* newer - versnum.l region.b name.pstr copyright.pstr */
	"802ArComment",
	"802BrBundle",
	"802CrFinderPath",
	"802DrPaletteWindow",
	"802ErTaggedStrings",
	"802FrPatternList",
	"ALRTAlert Dialog",
	"ASNDWorld Builder Sound",
	"BNDLIcon Bundle",
	"BRGRWolf Block",
	"C001rRectList",
	"C002rPrintRecord",
	"C003rFont", /* variable-sized */
	"CCI\xAAProduct Description",
	"CCODM68K Code",
	"CDEFM68K Control Def",
	"CHEKTime Stamp",
	"CNTLControl Description",
	"CODEM68K Code Segment",
	"CSTRC-String",
	"CURSCursor-Mono",
	"DATAInitial Data",
	"DESCDescription P-String",
	"DITLDialog Item List",
	"DLGXDialog Styling",
	"DLOGDialog Window",
	"DRELData Relocation Table",
	"DRVRM68K Driver/Accessory",
	"EMAPExtension table",
	"FKEYF-Key Shortcut Code",
	"FONDFont Description",
	"FONTBitmapped Font",
	"FREFBundle File Ref",
	"FRSVReserved Fonts-IDs",
	"FWIDFont Width Table",
	"FltrFilter Table",
	"HEXAMisc Data",
	/*HEXDHex dump*/
	"ICN#32x32 Icon/Mask-Mono",
	"ICON32x32 Icon-Mono",
	"INITM68K Extension Code",
	"INSTMidi Instrument Ref",
	"INTLNumber Formatting",
	"KCHRKey Character Map",
	"KCN#Keyboard Icons-Mono",
	"KSWPKeyboard Swapping",
	"LDEFM68K List Def",
	"MBARMenubar Description",
	"MBDFM68K Menubar Def",
	"MDEFM68K Menu Definition",
	"MDVRM68K Driver",
	"MENAMenu Acc. Key-Win32",
	"MENUBasic Menu",
	"MPSRMPW Record",
	/*MooVQT Movie*/
	"NAMEObject name",
	"NFNTBitmap Font",
	"NcmpPPC Decompressor",
	"PACKM68K Code Package",
	"PAT Pattern-Mono",
	"PAT#Pattern List-Mono",
	/*PDEFPrinter Driver*/
	"PICTQuickdraw Picture", /* 357 */
	"PLTEHyperCard palette",
	"POSTPostScript Data",
	"PPobWindow Template",
	/*PRECPrinter defaults*/
	"PROCM68K Procedure Code",
	"PTCHM68K Patch Code",
	"PtchCode Patch",
	"RECTRaw rectangle",
	"SERDSerial Driver",
	"SEngStuffIt Engine",
	"SICNSmall Icon List",
	"SIZEApp Allocation Info",
	"SOCKNet Socket Code",
	"SONGMidi Song Reference",
	"STR P-String",
	"STR#P-String List",
	"SetgArchive settings",
	"TEXTRaw text", /* 374 */
	"TMPLRsrc Template",
	"TxtrText style",
	"WDEFM68K Window Def",
	"WINDWindow Description",
	"WPosWindow Position",
	"XCMDM68K External Cmd",
	"XCODM68K External Code",
	"XFCNM68K External Func",
	"XREFReference table",
	"ZEROInitial zero spacing",
	"actbAlert Color Table",
	"acurAnimated Cursor List",
	"adioAudio Code",
	"aeteApple Event Table",
	/*alisAlias group*/
	"alrxExtended Alert",
	"atlkAppleTalk Code",
	"bcemDiskCopy Info",
	"bootBoot Code",
	"cardSlot Card Description",
	"cctbControl Color Table",
	"cdevControl Panel Code",
	"cfrgCode Fragment Info",
	"cicnColor Icon",
	"clokClock Timer Code",
	"clutColor Table",
	"cmdoMPW Commando",
	"crsrCursor-Color",
	"csndPacked Sound",
	"dastAccessory Description",
	"dcmpRsrc Decompressor",
	"dctbDialog Color Table",
	"dftbDialog Control Fonts",
	"dimgDisk Image Driver",
	"dlgxExtended Dialog",
	"dlleMultiplatform Things", /* cstr */
	"drvrDriver",
	"drvsDrive Descriptors",
	"errsError String List", /* min/max/ID */
	"fctbFont Color Table", /* added 2014.02.28 */
	"fil2Marathon 2 replay",
	"fil\266od28-6 replay",
	"finfFont Info List",
	"flacFlattened Collection",
	"fld#System Folder List",
	"flstFont Info List",
	"fmapFileType Map",
	/*fmnuFinder menu*/
	"fovrPPC Library",
	"ftagFile Tag",
	"fxltFile Translation",
	"gpchGeneral Patch",
	"hdlgHelp Balloon-Dialog",
	"hfdrHelp Balloon-Finder",
	"hmnuHelp Balloon-Menu",
	"hovrHelp Mgr Override",
	"hrctHelp Balloon-Rectangle",
	"hwinHelp Balloon-Windows",
	"icl432x32 Icon-4 bit",
	"icl832x32 Icon-8 bit",
	"icm#Mini Icon/Mask-Mono",
	"icm4Mini Icon-4 bit",
	"icm8Mini Icon-8 bit",
	"icmtInstaller item",
	"icnsIcon Collection",
	"ics#Small Icon/Mask-Mono",
	"ics4Small Icon-4 bit",
	"ics8Small Icon-8 bit",
	"ictbItem Style",
	"itl0Number Formatting",
	"itl1Date Formatting",
	/*itl2Region Language*/
	/*itlkNon-standard keys*/
	"kcl4Large KB Icon-4 bit",
	"kcl8Large KB Icon-8 bit",
	"kcs#Small KB Icon-Mono",
	"kcs4Small KB Icon-4 bit",
	"kcs8Small KB Icon-8 bit",
	"kindDesktop Kind Info",
	"ldesList Box Description",
	"lpchCode patch",
	"machMachine Requirements",
	"mcfgQT MIME Import Config",
	"mctbMenu Color Table",
	"mgrpQT Media Group",
	"mimeQT MIME Import Info", /* 'sean' type */
	"mitqMakeITable Queues",
	"mntrM68K Monitor Driver",
	"moovQT Movie Rsrc",
	"mst#Item Language Table",
	"mstrMenu Item P-String",
	"ncmpPPC Decompressor",
	"ndrvPPC Driver",
	"nrctRectangle List",
	"nsndPPC Sound Driver",
	"nsrdSerial Driver",
	"ntrbPPC Trap Patch",
	"openDesktop Open Enabler",
	"osaxM68K AppleScript",
	"otlmOpenTransport Loader",
	"pckiQTStreaming Pack Info",
	"perfCode Performance",
	"phy\266od28-6 definitions", /* 473 */
	"plttColor Palette",
	"pmapRaw PixMap",
	"pnotPreview Rsrc List",
	"ppatColor Pattern",
	"ppt#Color Pattern List",
	"procRaw procedure code",
	"psltNuBus pseudo-slots",
	"ptchM68K Patch",
	"puf!Text Mappings",
	"qtcmQuickTime Component",
	"resfReserved Fonts",
	"rgb 48-bit RGB Color",
	"rsmiReassembler Info",
	"scodSystem Code",
	"scptAppleScript",
	"scszScript Requirements",
	"sfntTruType Font",
	/*sfn#Fonts suitable*/
	"siftM68K Sound Mixer",
	"snd Sound List",
	"snthSound Synthesizer",
	"spceStack space",
	"sprtSprocket Data",
	"src#MovieExporter Sources",
	"ssaiMusical Instrument",
	"stg#QT Presets",
	"stgpQT Preset Platforms",
	"stylRaw text styling",
	"syszSys RAM Requirement",
	"tab#Tab Control",
	"termTerminal text",
	"thgaCM Thing",
	"thn#CM Thing Order",
	"thndCM Thing Dependency",
	"thngCM Thing List",
	"thnrCM Thing Public Map",
	"tmplData Template",
	"trk#MovieExporter Tracks",
	"ttssPhoneme Symbols",
	"vdigPPC Video Driver",
	"vdpmM68K Video Driver",
	"versVersion Info",
	"wctbWindow Color Table",
	"windExtensible Window-flac",
	"xcmdPPC External Command",
	"xfcnPPC External Func",
	"xmnuExtended Menu"
};

/* ---- code */

int rTypeGetIndex(uint32 t)
{
	const typeDesc	*s = rsrcTypes, *f;
	uint32		c = GET_ARRAY_COUNT(rsrcTypes);
	uint32		u = be32_native(t), v;
	/* a sorted list means we can speed up the search with this */
	while(c>4)
	{
		v = *(const int32*)(f=s+c/2);
		if (u<be32_native(v))
			c = (c+1)>>1;
		else
			s = f, c-= c/2;
	}
	do
		if (*(const uint32*)s==t)
			return s-rsrcTypes;
	while(++s,--c);
	return -1;
}

const char *rTypeGetDesc(int ix)
{
	if (ix+0u>=GET_ARRAY_COUNT(rsrcTypes))
		return 0;
	return rsrcTypes[ix];
}

#ifdef TEST_SORT_ORDER
 #include <stdio.h>
 #include <stdlib.h>

int main(int argc,
	char **argv)
{
	const typeDesc	*s = rsrcTypes;
	uint32		v, t = 0;
	int		c = GET_ARRAY_COUNT(rsrcTypes);

	do
	{
		v = be32_native(*(const uint32*)s);
		if (v<t)
		{
			printf("### found out-of-order entry at '%.32s'\n\n",
				(const char*)s);
			exit(1);
		}
	} while(t=v,++s,--c);
	printf("# list checks out!\n\n");
}
#endif
