/*
 eval_op.h
  Version 1.9.9
*/

#ifndef __EVAL_OP_H
 #define __EVAL_OP_H

/* ---- constants */

typedef enum
{/* operator types */
 /* unary - all-type */
	_op_ldv,	/* (load / reference) */
	_op_ldi,	/* @	(load indirect) */
	_op_dno,	/* double-not (optimized !!b) */
	_op_bno,	/* !	(boolean not - no fp) */

	_op_srt,	/* ~/	[or]	CHR_RA */
	_op_abs,	/* + */
	_op_neg,	/* -	[or]	CHR_MN */
	_op_not,	/* ~	(-1-n compliment) */
#ifdef ALLOW_BIN_HI_LO
	_op_blo,	/* <	(binary low byte) */
	_op_bhi,	/* >	(binary high byte) */
#endif
 /* dyadic binary/logic/shift - no-fp */
/*010*/ _op_and,	/* & */
	_op_eor,	/* ^ */
	_op_ior,	/* | */
	_op_ban,	/* && */

	_op_bor,	/* || */
	_op_asr,	/* >>> */
	_op_shr,	/* >> */
	_op_shl,	/* << */
 /* dyadic math - all-type */
/*020*/	_op_add,	/* + */
	_op_sub,	/* - */
	_op_mul,	/* * */
	_op_pow,	/* ** */

	_op_div,	/* / */
	_op_dvs,	/* //	[or]	CHR_DV */
	_op_mod,	/* % */
	_op_mds,	/* %% */
 /* dyadic compare - all-type */
/*030*/	_op_clt,	/* <	(less than) */
	_op_cge,	/* >=	(greater or equal) */
	_op_cgt,	/* >	(greater than) */
	_op_cle,	/* <=	(less or equal) */

	_op_cne,	/* !=	[or]	CHR_NE */
	_op_ceq,	/* = */
	_op_cni,	/* <>	(not identical) */
	_op_cid,	/* ==	(identical) */

/*040*/	_op_cae,	/* ~=	[or]	CHR_AE	(almost equal - dbl32 compare) */
	_op_cnj,	/* (value*) */
	_op_rml,	/* run-on multiply (behaves more unary) */
	/* precedence codes, for algebraic and code ordering */
	_pr_fn,

	_pr_pow,
	_pr_mdv,
	_pr_ads,
	_pr_shx,

/*050*/	_pr_ciq,	/* inequality: <  <=  >  >= */
	_pr_ceq,
	_pr_and,
	_pr_eor,

	_pr_ior,
	_pr_ban,
	_pr_bor,
	_pr_cnd,	/* ? : */
	/* the dyadics are repeated in a 'set' read-mod-write context */
/*060*/	_opd_add,	/* +=> */
	_op_stv		= _op_clt|040,	/* ==>	(store) */
	_op_ret,	/* return - terminator in stack parsing */
	_op_jsr,

/* first to last unary -- must update if changed */
	_op_una		= _op_ldv,
	_op_unb		= _op_and-1,

	_op_obj		= 0xFFFF,	/* value (instead of a symbol) in parsing */
	_op_mask	= 0x3F,		/* expr op index mask (6 bits) */
 #if INTERP_VERS>0x199
	/* lexical keywords */
	_lexk_if,
	_lexk_if_t,	/* requires then */
	_lexk_if_p,	/* requires parentheses */
	_lexk_else,

	_lexk_then,
	_lexk_then_b,	/* requires an equal 'true' or 'false' pattern */
	_lexk_goto,
	_lexk_end,

	_lexk_do,
	_lexk_while,
	_lexk_for,
	_lexk_continue,

	_lexk_break,
	_lexk_case,
	_lexk_default,
	_lexk_switch,

	_lexk_sizeof,
	_lexk_typeof,
	_lexk_local,
	_lexk_global,

	_lexk_const,
	_lexk_var,
	_lexk_auto,
	_lexk_enum,

	_lexk_repeat,	/* uses internal counter if not followed by 'while' */
	_lexk_until,
	_lexk_to,
	_lexk_into
 #endif
} evalop;
#endif
