/*
 mencoding.h
*/

#include <enviro64.h>

/* ---- constants */

typedef enum
{ /* IANA/MIB block */
	_cs_blank		= 0,
	_cs_other,
	_cs_unknown,
	_csASCII,
	_csISO8859_1,
	_csISO8859_2,
	_csISO8859_3,
	_csISO8859_4,
	_csISO8859_5,
	_csISO8859_6,
	_csISO8859_7,
	_csISO8859_8,
	_csISO8859_9,
	_csISO8859_10,
	_csISOLatin1		= _csISO8859_1,
	_csISOLatin2,
	_csISOLatin3,
	_csISOLatin4,
	_csLatinCyrillic,
	_csLatinArabic,
	_csLatinGreek,
	_csLatinHebrew,
	_csISOLatin5,
	_csISOLatin6,
	_csISOTextComm,
	_csHalfWidthKatakana,
	_csJISEncoding,
	_csShiftJIS,
	_csEUCPkdFmtJapanese,
	_csEUCFixWidJapanese,
	_csISO4UnitedKingdom,
	_csISO11SwedishForNames,
	_csISO15Italian,
	_csISO17Spanish,
	_csISO21German,
	_csISO60DanishNorwegian,
	_csISO69French,
	_csISO10646UTF1,
	_csISO646basic1983,
	_csINVARIANT,
	_csISO2IntlRefVersion,
	_csNATSSEFI,
	_csNATSSEFIADD,
	_csNATSDANO,
	_csNATSDANOADD,
	_csISO10Swedish,
	_csKSC56011987,
	_csISO2022KR,
	_csEUCKR,
	_csISO2022JP,
	_csISO2022JP2,
	_csISO13JISC6220jp,
	_csISO14JISC6220ro,
	_csISO16Portuguese,
	_csISO18Greek7Old,
	_csISO19LatinGreek,
	_csISO25French,
	_csISO27LatinGreek1,
	_csISO5427Cyrillic,
	_csISO42JISC62261978,
	_csISO47BSViewdata,
	_csISO49INIS,
	_csISO50INIS8,
	_csISO51INISCyrillic,
	_csISO54271981,
	_csISO5428Greek,
	_csISO57GB1988,
	_csISO58GB231280,
	_csISO61Norwegian2,
	_csISO70VideotexSupp1,
	_csISO84Portuguese2,
	_csISO85Spanish2,
	_csISO86Hungarian,
	_csISO87JISX0208,
	_csISO88Greek7,
	_csISO89ASMO449,
	_csISO90,
	_csISO91JISC62291984a,
	_csISO92JISC62991984b,
	_csISO93JIS62291984badd,
	_csISO94JIS62291984hand,
	_csISO95JIS62291984handadd,
	_csISO96JISC62291984kana,
	_csISO2033,
	_csISO99NAPLPS,
	_csISO102T617bit,
	_csISO103T618bit,
	_csISO111ECMACyrillic,
	_cs_a71,
	_cs_a72,
	_csISO123CSAZ24341985gr,
	_csISO88596E,
	_csISO88596I,
	_csISO128T101G2,
	_csISO88598E,
	_csISO88598I,
	_csISO139CSN369103,
	_csISO141JUSIB1002,
	_csISO143IECP271,
	_csISO146Serbian,
	_csISO147Macedonian,
	_csISO150,
	_csISO151Cuba,
	_csISO6937Add,
	_csISO153GOST1976874,
	_csISO8859Supp,
	_csISO10367Box,
	_csISO158Lap,
	_csISO159JISX02121990,
	_csISO646Danish,
	_csUSDK,
	_csDKUS,
	_csKSC5636,
	_csUnicode11UTF7,
	_csISO2022CN,
	_csISO2022CNEXT,
	_csUTF8,
	_csISO885913,
	_csISO885914,
	_csISO885915,
	_csISO885916,
	_csGBK,
	_csGB18030,
	_csOSDEBCDICDF0415,
	_csOSDEBCDICDF03IRV,
	_csOSDEBCDICDF041,
	_csISO115481,
	_csKZ1048,
	_csUCS2			= 1000,
	_csUCS4,
	_csUCSbasic,
	_csUnicodeLatin1,
	_csUnicodeJapanese,
	_csUnicodeIBM1261,
	_csUnicodeIBM1268,
	_csUnicodeIBM1276,
	_csUnicodeIBM1264,
	_csUnicodeIBM1265,
	_csUnicode11,
	_csSCSU,
	_csUTF7,
	_csUTF16BE,
	_csUTF16LE,
	_csUTF16,
	_csCESU8,
	_csUTF32,
	_csUTF32BE,
	_csUTF32LE,
	_csBOCU1,
	_csUTF7IMAP,
	_csWindows30Latin1	= 2000,
	_csWindows31Latin1,
	_csWindows31Latin2,
	_csWindows31Latin5,
	_csHPRoman8,
	_csAdobeStandardEncoding,
	_csVenturaUS,
	_csVenturaInternational,
	_csDECMCS,
	_csPC850Multilingual,
	_csPCp852,
	_csPC8CodePage437,
	_csPC8DanishNorwegian,
	_csPC862LatinHebrew,
	_csPC8Turkish,
	_csIBMSymbols,
	_csIBMThai,
	_csHPLegal,
	_csHPPiFont,
	_csHPMath8,
	_csHPPSMath,
	_csHPDesktop,
	_csVenturaMath,
	_csMicrosoftPublishing,
	_csWindows31J,
	_csGB2312,
	_csBig5,
	_csMacRoman,
	_csIBM037,
	_csIBM038,
	_csIBM273,
	_csIBM274,
	_csIBM275,
	_csIBM277,
	_csIBM278,
	_csIBM280,
	_csIBM281,
	_csIBM284,
	_csIBM285,
	_csIBM290,
	_csIBM297,
	_csIBM420,
	_csIBM423,
	_csIBM424,
	_csIBM500,
	_csIBM851,
	_csIBM855,
	_csIBM857,
	_csIBM860,
	_csIBM861,
	_csIBM863,
	_csIBM864,
	_csIBM865,
	_csIBM868,
	_csIBM869,
	_csIBM870,
	_csIBM871,
	_csIBM880,
	_csIBM891,
	_csIBM903,
	_csIBBM904,
	_csIBM905,
	_csIBM918,
	_csIBM1026,
	_csEBCDICATDEA,
	_csEBCDICCAFR,
	_csEBCDICDKNO,
	_csEBCDICDKNOA,
	_csEBCDICFISE,
	_csEBCDICFISEA,
	_csEBCDICFR,
	_csEBCDICIT,
	_csEBCDICPT,
	_csEBCDICES,
	_csEBCDICESA,
	_csEBCDICESS,
	_csEBCDICUK,
	_csEBCDICUS,
	_cs_unknown8bit,
	_csMnemonic,
	_csMnem,
	_csVISCII,
	_csVIQR,
	_csKOI8R,
	_csHZGB2312,
	_csIBM866,
	_csPC775Baltic,
	_csKOI8U,
	_csIBM00858,
	_csIBM00924,
	_csIBM01140,
	_csIBM01141,
	_csIBM01142,
	_csIBM01143,
	_csIBM01144,
	_csIBM01145,
	_csIBM01146,
	_csIBM01147,
	_csIBM01148,
	_csIBM01149,
	_csBig5HKSCS,
	_csIBM1047,
	_csPTCP154,
	_csAmiga1251,
	_csKOI7switched,
	_csBRF,
	_csTSCII,
	_csCP51932,
	_csWindows874,
	_csWindows1250		= 2250,
	_csWindows1251,
	_csWindows1252,
	_csWindows1253,
	_csWindows1254,
	_csWindows1255,
	_csWindows1256,
	_csWindows1257,
	_csWindows1258,
	_csTIS620,
	_cs50220,
	_cs_reserved		= 3000,

 /* MS codepages for non-IANA values */
	_cpMacRoman		= 10000, /* Windows' translator-specific */
	_cpMacJapanese,
	_cpMacChineseTrad,
	_cpMacKorean,
	_cpMacArabic,
	_cpMacHebrew,
	_cpMacGreek,
	_cpMacCyrillic,
	_cpMacChineseSimp,
	_cpMacRomanian,
	_cpMacUkranian,
	_cpMacThai,
	_cpMacCE,
	_cpMacIcelandic,
	_cpMacTurkish,
	_cpMacCroatian,
	_cpISO8859_1		= 28591,
	_cpISO8859_2,
	_cpISO8859_3,
	_cpISO8859_4,
	_cpISO8859_5,
	_cpISO8859_6,
	_cpISO8859_7,
	_cpISO8859_8,
	_cpISO8859_9,
	_cpISO8859_10,
	_cpISO8859_11,
	_cpISO8859_12,
	_cpISO8859_13,
	_cpISO8859_14,
	_cpISO8859_15,
	_cpISO8859_6I		= 38596,
	_cpISO8859_8I		= 38598,
	_cpUTF8			= 65001,

	_cs_default8bit		= _csWindows1252
} _cxEncoding;

#define UTF32_CHAR_MASK		0x001FFFFF
#define UTF32_MAX_LEGAL		0x0010FFFF
#define UTF32_UNKNOWN		0x0000FFFD
#define UTF32_ILLEGAL		0x40000000	/* flag */

#define UCSX_LIG		(1<<24)	/* ligature - LLXXXX is leading for XXHHXX set ending */
#define UCSX_P6A		(1<<25)	/* priv.use F86A combo leading */
#define UCSX_P7F		(1<<26)	/* priv.use F87F combo ending */
#define UCSX_RLO		(1<<27) /* right-to-left */
#define UCSX_LRO		(2<<27) /* left-to-right */
#define UCSX_PDF		(3<<27) /* POP directional formatting */
#define UCSX_OMASK		(3<<27)

/* cxReadChar will only return a char with this bit when ordering has changed to indicate
  that the char is not part of the original stream; the char can be ignored by parsers
*/
#define USCXC_DIR		(1<<23)

/* ---- macros */

#define _dfN(s)			sizeof(s)-1,s

/* ---- typedefs */

#define cb_utf_reader(x)	int __cdecl x(const uint8 **in)
#define cb_utf_writer(x)	int __cdecl x(int i, uint8 **out)

typedef cb_utf_reader((*csUTF_reader)); /* return char., updates position */
typedef cb_utf_writer((*csUTF_writer));

typedef struct csXTag
{
	uint16		ID;
	uint8		nlength;
	const char	*name;
} csXTag;

typedef struct csXReadBuf
{
	csUTF_reader	readCh;
	uint8		buf[16], size;
	int		cur, next, dir;
} csXReadBuf;

/* ---- globals */

extern const uint16	__UCS2_WCP1252[256], __UCS2_WCP1250_high[128];
extern const uint16	__UCS2_MacRoman[256], __UCS2_MacGreek_high[128];

/* ---- prototypes */

extern csUTF_reader csGetUTFReader(int tEncoding);
extern int csTestBOM(FILE *s);

extern int cxWriteUCSX(int32 x,
	cb_utf_writer(f), // must be valid
	uint8 **out, // must be valid
	int *curDir); // must be valid

/* this routine is used to build the Unicode stream in reading with all translated characters */
/* Note that it may add a character with USCXC_DIR for some encodings; see the above comment */
extern int32 cxReadChar(FILE *s, // must be valid
	csXReadBuf *b); // must be valid

int csGetXTag(const csXTag *tags,
	const char *n,
	int z);

cb_utf_writer(writeUTF_UTF8);
cb_utf_writer(writeUTF_MacRoman);

#ifndef NO_TABLES
extern const csXTag	ml_MIME_encodings[];
#endif
